Index: code/branches/pickup2/src/libraries/network/ClientConnection.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/ClientConnection.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/ClientConnection.cc	(revision 6412)
@@ -38,6 +38,6 @@
   const unsigned int NETWORK_CLIENT_WAIT_TIME = 1;
   const unsigned int NETWORK_CLIENT_CONNECTION_TIMEOUT = 3000; //millisecs
-  const unsigned int NETWORK_CLIENT_MAX_CONNECTIONS = 5;
-  const unsigned int NETWORK_CLIENT_CHANNELS = 2;
+  const unsigned int NETWORK_CLIENT_MAX_CONNECTIONS = 1;
+  const unsigned int NETWORK_CLIENT_CHANNELS = 1;
 
 
@@ -69,5 +69,5 @@
   {
     ENetEvent event;
-    
+
     this->host_ = enet_host_create(NULL, NETWORK_CLIENT_MAX_CONNECTIONS, 0, 0);
     if ( this->host_ == NULL )
@@ -99,5 +99,5 @@
   bool ClientConnection::closeConnection() {
     ENetEvent event;
-    
+
     if ( !this->established_ )
       return true;
@@ -147,3 +147,9 @@
   }
 
+  uint32_t ClientConnection::getRTT()
+  {
+    assert(server_);
+    return server_->roundTripTime;
+  }
+
 }
Index: code/branches/pickup2/src/libraries/network/ClientConnection.h
===================================================================
--- code/branches/pickup2/src/libraries/network/ClientConnection.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/ClientConnection.h	(revision 6412)
@@ -26,5 +26,5 @@
  *
  */
- 
+
 #ifndef _ClientConnection_H__
 #define _ClientConnection_H__
@@ -40,8 +40,8 @@
     ClientConnection();
     virtual ~ClientConnection();
-    
+
     void setServerAddress( const std::string& serverAddress );
     void setPort( unsigned int port );
-    
+
     ENetEvent *getEvent();
     // check wheter the packet queue is empty
@@ -55,8 +55,9 @@
   protected:
     virtual void connectionClosed()=0;
+    uint32_t getRTT();
   private:
     virtual void addPeer(ENetEvent* event);
     virtual void removePeer(ENetEvent* event);
-    
+
     bool disconnectConnection();
     // enet stuff
Index: code/branches/pickup2/src/libraries/network/ClientInformation.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/ClientInformation.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/ClientInformation.cc	(revision 6412)
@@ -42,8 +42,9 @@
 #define WIN32_LEAN_AND_MEAN
 #include <enet/enet.h>
+#include "ClientConnectionListener.h"
 
 namespace orxonox
 {
-  
+
 
   ClientInformation *ClientInformation::head_=0;
@@ -66,4 +67,5 @@
     if(this==head_)
       head_=next();
+    ClientConnectionListener::broadcastClientDisconnected( this->getID() );
   }
 
Index: code/branches/pickup2/src/libraries/network/GamestateClient.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/GamestateClient.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/GamestateClient.cc	(revision 6412)
@@ -54,5 +54,5 @@
       std::map<unsigned int, packet::Gamestate *>::iterator it;
       for ( it = this->gamestateMap_.begin(); it != this->gamestateMap_.end(); ++it )
-          delete (*it).second;
+          delete it->second;
       if( this->tempGamestate_ )
           delete this->tempGamestate_;
@@ -81,8 +81,8 @@
     packet::Gamestate *processed = processGamestate(tempGamestate_);
     assert(processed);
-    
+
     //now call the queued callbacks
     NetworkCallbackManager::callCallbacks();
-    
+
     if (!processed){
       sendAck(0);
@@ -126,5 +126,5 @@
         break;
       // otherwise delete that stuff
-      delete (*it).second;
+      delete it->second;
       temp=it++;
       gamestateMap_.erase(temp);
@@ -137,5 +137,5 @@
     COUT(4) << "gamestates: ";
     for(it=gamestateMap_.begin(); it!=gamestateMap_.end(); it++){
-      COUT(4) << it->first << ":" << it->second << "|";
+      COUT(4) << it->first << ':' << it->second << '|';
     }
     COUT(4) << std::endl;
Index: code/branches/pickup2/src/libraries/network/GamestateManager.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/GamestateManager.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/GamestateManager.cc	(revision 6412)
@@ -69,5 +69,5 @@
         delete this->reference;std::map<unsigned int, packet::Gamestate*>::iterator it;
     for( it = gamestateQueue.begin(); it != gamestateQueue.end(); ++it )
-      delete (*it).second;
+      delete it->second;
     std::map<unsigned int, std::map<unsigned int, packet::Gamestate*> >::iterator it1;
     std::map<unsigned int, packet::Gamestate*>::iterator it2;
@@ -75,5 +75,5 @@
     {
       for( it2 = it1->second.begin(); it2 != it1->second.end(); ++it2 )
-        delete (*it2).second;
+        delete it2->second;
     }
     this->trafficControl_->destroy();
@@ -126,5 +126,5 @@
     return true;
   }
-  
+
   void GamestateManager::sendGamestates()
   {
@@ -142,9 +142,9 @@
       COUT(5) << "Server: doing gamestate gamestate preparation" << std::endl;
       int cid = temp->getID(); //get client id
-      
+
       unsigned int gID = temp->getGamestateID();
       if(!reference)
         return;
-      
+
       packet::Gamestate *client=0;
       if(gID != GAMESTATEID_INITIAL){
@@ -156,8 +156,8 @@
         }
       }
-      
+
       clientGamestates.push(0);
       finishGamestate( cid, &clientGamestates.back(), client, reference );
-      //FunctorMember<GamestateManager>* functor = 
+      //FunctorMember<GamestateManager>* functor =
 //       ExecutorMember<GamestateManager>* executor = createExecutor( createFunctor(&GamestateManager::finishGamestate, this) );
 //       executor->setDefaultValues( cid, &clientGamestates.back(), client, reference );
@@ -165,10 +165,10 @@
 //       this->threadPool_->passFunction( executor, true );
 //       (*functor)( cid, &(clientGamestates.back()), client, reference );
-      
+
       temp = temp->next();
     }
-    
+
 //     threadPool_->synchronise();
-    
+
     while( !clientGamestates.empty() )
     {
@@ -185,5 +185,5 @@
     // save the (undiffed) gamestate in the clients gamestate map
     //chose wheather the next gamestate is the first or not
-    
+
     packet::Gamestate *gs = gamestate->doSelection(clientID, 20000);
 //     packet::Gamestate *gs = new packet::Gamestate(*gamestate);
@@ -193,8 +193,8 @@
     gamestateMap_[clientID][gamestate->getID()]=gs;
 //     this->threadMutex_->unlock();
-    
+
     if(base)
     {
-        
+
 //       COUT(3) << "diffing" << std::endl;
 //       packet::Gamestate* gs1  = gs;
@@ -210,6 +210,6 @@
       gs = new packet::Gamestate(*gs);
     }
-    
-    
+
+
     bool b = gs->compressData();
     assert(b);
Index: code/branches/pickup2/src/libraries/network/Host.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/Host.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/Host.cc	(revision 6412)
@@ -50,4 +50,6 @@
   assert(instance_==0);
   instance_=this;
+  this->printRTTCC_ = createConsoleCommand( createFunctor(&Host::printRTT, this), "printRTT" );
+  CommandExecutor::addConsoleCommandShortcut( this->printRTTCC_ );
 }
 
@@ -59,4 +61,6 @@
 {
   instance_=0;
+  if( this->printRTTCC_ )
+    delete this->printRTTCC_;
 }
 
Index: code/branches/pickup2/src/libraries/network/Host.h
===================================================================
--- code/branches/pickup2/src/libraries/network/Host.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/Host.h	(revision 6412)
@@ -31,4 +31,5 @@
 
 #include "NetworkPrereqs.h"
+#include "core/CorePrereqs.h"
 
 namespace orxonox {
@@ -44,5 +45,5 @@
 *       - defines static functions available on both server and client
 *       - is the interface to be used when communicating with the network
-*	@author Oliver Scheuss
+*       @author Oliver Scheuss
 */
 class _NetworkExport Host{
@@ -79,5 +80,7 @@
     static bool Broadcast(const std::string& message);
     static bool incomingChat(const std::string& message, unsigned int playerID);
+    virtual void printRTT()=0;
   private:
+    ConsoleCommand* printRTTCC_;
 };
 
Index: code/branches/pickup2/src/libraries/network/NetworkFunction.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/NetworkFunction.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/NetworkFunction.cc	(revision 6412)
@@ -32,10 +32,6 @@
 namespace orxonox
 {
-  std::map<std::string, NetworkFunctionBase*> NetworkFunctionBase::nameMap_;
   std::map<uint32_t, bool> NetworkFunctionBase::isStaticMap_;
-  
-  std::map<NetworkFunctionPointer, NetworkFunctionStatic*> NetworkFunctionStatic::functorMap_;
-  std::map<uint32_t, NetworkFunctionStatic*> NetworkFunctionStatic::idMap_;
-      
+
   std::map<NetworkFunctionPointer, NetworkMemberFunctionBase*> NetworkMemberFunctionBase::functorMap_;
   std::map<uint32_t, NetworkMemberFunctionBase*> NetworkMemberFunctionBase::idMap_;
@@ -44,54 +40,73 @@
   {
     RegisterRootObject(NetworkFunctionBase);
-    
+
     static uint32_t networkID = 0;
     this->networkID_ = networkID++;
-    
+
     this->name_ = name;
-    nameMap_[name] = this;
+    NetworkFunctionBase::getNameMap()[name] = this;
   }
   NetworkFunctionBase::~NetworkFunctionBase()
   {
   }
-  
-  
+
+
   void NetworkFunctionBase::destroyAllNetworkFunctions()
   {
+    std::map<std::string, NetworkFunctionBase*>& map = NetworkFunctionBase::getNameMap();
     std::map<std::string, NetworkFunctionBase*>::iterator it;
-    for( it=NetworkFunctionBase::nameMap_.begin(); it!=NetworkFunctionBase::nameMap_.end(); ++it )
+    for( it=map.begin(); it!=map.end(); ++it )
       it->second->destroy();
   }
-  
-  
+
+
+  /*static*/ std::map<std::string, NetworkFunctionBase*>& NetworkFunctionBase::getNameMap()
+  {
+    static std::map<std::string, NetworkFunctionBase*> nameMap_;
+    return nameMap_;
+  }
+
+
   NetworkFunctionStatic::NetworkFunctionStatic(FunctorStatic* functor, const std::string& name, const NetworkFunctionPointer& p):
     NetworkFunctionBase(name)
   {
     RegisterObject(NetworkFunctionStatic);
-    
+
     this->functor_ = functor;
-    functorMap_[p] = this;
-    idMap_[ this->getNetworkID() ] = this;
+    NetworkFunctionStatic::getFunctorMap()[p] = this;
+    NetworkFunctionStatic::getIdMap()[ this->getNetworkID() ] = this;
   }
-  
+
   NetworkFunctionStatic::~NetworkFunctionStatic()
   {
     delete this->functor_;
   }
-  
-  
-  
+
+  /*static*/ std::map<NetworkFunctionPointer, NetworkFunctionStatic*>& NetworkFunctionStatic::getFunctorMap()
+  {
+    static std::map<NetworkFunctionPointer, NetworkFunctionStatic*> functorMap_;
+    return functorMap_;
+  }
+
+  /*static*/ std::map<uint32_t, NetworkFunctionStatic*>& NetworkFunctionStatic::getIdMap()
+  {
+    static std::map<uint32_t, NetworkFunctionStatic*> idMap_;
+    return idMap_;
+  }
+
+
   NetworkMemberFunctionBase::NetworkMemberFunctionBase(const std::string& name, const NetworkFunctionPointer& p):
     NetworkFunctionBase(name)
   {
     RegisterObject(NetworkMemberFunctionBase);
-    
-    functorMap_[p] = this;
-    idMap_[ this->getNetworkID() ] = this;
+
+    this->functorMap_[p] = this;
+    this->idMap_[ this->getNetworkID() ] = this;
   }
-  
+
   NetworkMemberFunctionBase::~NetworkMemberFunctionBase()
   {
   }
-  
+
 
 }
Index: code/branches/pickup2/src/libraries/network/NetworkFunction.h
===================================================================
--- code/branches/pickup2/src/libraries/network/NetworkFunction.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/NetworkFunction.h	(revision 6412)
@@ -74,22 +74,27 @@
     NetworkFunctionBase(const std::string& name);
     ~NetworkFunctionBase();
-    
+
     virtual void        setNetworkID(uint32_t id)       { this->networkID_ = id; }
     inline uint32_t     getNetworkID() const            { return this->networkID_; }
     inline const std::string& getName() const           { return name_; }
     static inline bool  isStatic( uint32_t networkID )  { return isStaticMap_[networkID]; }
-    
-    static inline void setNetworkID(const std::string& name, uint32_t id){ assert( nameMap_.find(name)!=nameMap_.end() ); nameMap_[name]->setNetworkID(id); }
-    
+
+    static inline void setNetworkID(const std::string& name, uint32_t id)
+    {
+        std::map<std::string, NetworkFunctionBase*>& map = NetworkFunctionBase::getNameMap();
+        assert( map.find(name)!=map.end() );
+        map[name]->setNetworkID(id);
+    }
+
     static void destroyAllNetworkFunctions();
-    
+
   protected:
     static std::map<uint32_t, bool> isStaticMap_;
-    
-  private:
-    static std::map<std::string, NetworkFunctionBase*> nameMap_;
+
+  private:
+    static std::map<std::string, NetworkFunctionBase*>& getNameMap();
     uint32_t networkID_;
     std::string name_;
-      
+
 };
 
@@ -99,5 +104,5 @@
     NetworkFunctionStatic(FunctorStatic* functor, const std::string& name, const NetworkFunctionPointer& p);
     ~NetworkFunctionStatic();
-    
+
     inline void call(){ (*this->functor_)(); }
     inline void call(const MultiType& mt1){ (*this->functor_)(mt1); }
@@ -106,16 +111,19 @@
     inline void call(const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4){ (*this->functor_)(mt1, mt2, mt3, mt4); }
     inline void call(const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4, const MultiType& mt5){ (*this->functor_)(mt1, mt2, mt3, mt4, mt5); }
-    
-    virtual void setNetworkID( uint32_t id ){ NetworkFunctionBase::setNetworkID( id ); idMap_[id] = this; }
-    static inline NetworkFunctionStatic* getNetworkFunction( uint32_t id){ assert( idMap_.find(id)!=idMap_.end() ); return idMap_[id]; }
-    static NetworkFunctionStatic* getFunction( uint32_t id ){ assert( idMap_.find(id) != idMap_.end() ); return idMap_[id]; }
-    static NetworkFunctionStatic* getFunction( const NetworkFunctionPointer& p ){ assert( functorMap_.find(p) != functorMap_.end() ); return functorMap_[p]; }
-    
-  private:
-    static std::map<NetworkFunctionPointer, NetworkFunctionStatic*> functorMap_;
-    static std::map<uint32_t, NetworkFunctionStatic*> idMap_;
-    
+
+    virtual void setNetworkID( uint32_t id )
+        { NetworkFunctionBase::setNetworkID( id ); NetworkFunctionStatic::getIdMap()[id] = this; }
+    static inline NetworkFunctionStatic* getNetworkFunction( uint32_t id)
+        { assert( NetworkFunctionStatic::getIdMap().find(id)!=NetworkFunctionStatic::getIdMap().end() ); return NetworkFunctionStatic::getIdMap()[id]; }
+    static NetworkFunctionStatic* getFunction( uint32_t id )
+        { assert( NetworkFunctionStatic::getIdMap().find(id) != NetworkFunctionStatic::getIdMap().end() ); return NetworkFunctionStatic::getIdMap()[id]; }
+    static NetworkFunctionStatic* getFunction( const NetworkFunctionPointer& p )
+        { assert( NetworkFunctionStatic::getFunctorMap().find(p) != NetworkFunctionStatic::getFunctorMap().end() ); return NetworkFunctionStatic::getFunctorMap()[p]; }
+
+  private:
+    static std::map<NetworkFunctionPointer, NetworkFunctionStatic*>& getFunctorMap();
+    static std::map<uint32_t, NetworkFunctionStatic*>& getIdMap();
     FunctorStatic* functor_;
-    
+
 };
 
@@ -125,11 +133,11 @@
     NetworkMemberFunctionBase(const std::string& name, const NetworkFunctionPointer& p);
     ~NetworkMemberFunctionBase();
-    
+
     virtual void setNetworkID( uint32_t id ){ NetworkFunctionBase::setNetworkID( id ); idMap_[id] = this; }
     static inline NetworkMemberFunctionBase* getNetworkFunction( uint32_t id){ assert( idMap_.find(id)!=idMap_.end() ); return idMap_[id]; }
     static NetworkMemberFunctionBase* getFunction( uint32_t id ){ assert( idMap_.find(id) != idMap_.end() ); return idMap_[id]; }
     static NetworkMemberFunctionBase* getFunction( const NetworkFunctionPointer& p ){ assert( functorMap_.find(p) != functorMap_.end() ); return functorMap_[p]; }
-    
-    // 
+
+    //
     virtual void call(uint32_t objectID)=0;
     virtual void call(uint32_t objectID, const MultiType& mt1)=0;
@@ -138,5 +146,5 @@
     virtual void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4)=0;
     virtual void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4, const MultiType& mt5)=0;
-    
+
   private:
     static std::map<NetworkFunctionPointer, NetworkMemberFunctionBase*> functorMap_;
@@ -149,36 +157,36 @@
     NetworkMemberFunction(FunctorMember<T>* functor, const std::string& name, const NetworkFunctionPointer& p);
     ~NetworkMemberFunction();
-    
+
     inline void call(uint32_t objectID)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)));
     }
     inline void call(uint32_t objectID, const MultiType& mt1)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)), mt1);
     }
     inline void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)), mt1, mt2);
     }
     inline void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)), mt1, mt2, mt3);
     }
     inline void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)), mt1, mt2, mt3, mt4);
     }
     inline void call(uint32_t objectID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4, const MultiType& mt5)
-    { 
+    {
       if ( Synchronisable::getSynchronisable(objectID)!=0 )
         (*this->functor_)(orxonox_cast<T*>(Synchronisable::getSynchronisable(objectID)), mt1, mt2, mt3, mt4, mt5);
     }
-    
+
   private:
     FunctorMember<T>* functor_;
Index: code/branches/pickup2/src/libraries/network/NetworkPrereqs.h
===================================================================
--- code/branches/pickup2/src/libraries/network/NetworkPrereqs.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/NetworkPrereqs.h	(revision 6412)
@@ -144,4 +144,6 @@
   template <class T>
   class NetworkCallback;
+  template <class T, class U>
+  class NetworkCallbackNotify;
   class NetworkCallbackBase;
   class NetworkCallbackManager;
Index: code/branches/pickup2/src/libraries/network/Server.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/Server.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/Server.cc	(revision 6412)
@@ -137,13 +137,13 @@
     // receive incoming packets
     Connection::processQueue();
-    
+
     if ( ClientInformation::hasClients() )
     {
       // process incoming gamestates
       GamestateManager::processGamestates();
-      
+
       // send function calls to clients
       FunctionCallManager::sendCalls();
-      
+
       //this steers our network frequency
       timeSinceLastUpdate_+=time.getDeltaTime();
@@ -160,11 +160,17 @@
     return ServerConnection::addPacket(packet, clientID);
   }
-  
-  /**
-   * @brief: returns ping time to client in milliseconds 
+
+  /**
+   * @brief: returns ping time to client in milliseconds
    */
-  unsigned int Server::getPing(unsigned int clientID){
+  unsigned int Server::getRTT(unsigned int clientID){
     assert(ClientInformation::findClient(clientID));
     return ClientInformation::findClient(clientID)->getRTT();
+  }
+
+  void Server::printRTT()
+  {
+    for( ClientInformation* temp=ClientInformation::getBegin(); temp!=0; temp=temp->next() )
+      COUT(0) << "Round trip time to client with ID: " << temp->getID() << " is " << temp->getRTT() << " ms" << endl;
   }
 
@@ -299,5 +305,5 @@
     {
       //ServerConnection::disconnectClient( client );
-      ClientConnectionListener::broadcastClientDisconnected( client->getID() );
+      //ClientConnectionListener::broadcastClientDisconnected( client->getID() ); //this is done in ClientInformation now
       delete client;
     }
@@ -311,8 +317,8 @@
     }
     COUT(5) << "Con.Man: creating client id: " << temp->getID() << std::endl;
-    
+
     // synchronise class ids
     syncClassid(temp->getID());
-    
+
     // now synchronise functionIDs
     packet::FunctionIDs *fIDs = new packet::FunctionIDs();
@@ -320,5 +326,5 @@
     bool b = fIDs->send();
     assert(b);
-    
+
     temp->setSynched(true);
     COUT(4) << "sending welcome" << std::endl;
@@ -338,10 +344,10 @@
     return true;
   }
-  
+
   void Server::disconnectClient( ClientInformation *client ){
     ServerConnection::disconnectClient( client );
     GamestateManager::removeClient(client);
     // inform all the listeners
-    ClientConnectionListener::broadcastClientDisconnected(client->getID());
+    // ClientConnectionListener::broadcastClientDisconnected(client->getID()); // this is done in ClientInformation now
   }
 
Index: code/branches/pickup2/src/libraries/network/Server.h
===================================================================
--- code/branches/pickup2/src/libraries/network/Server.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/Server.h	(revision 6412)
@@ -57,5 +57,6 @@
     bool queuePacket(ENetPacket *packet, int clientID);
     void update(const Clock& time);
-    unsigned int getPing(unsigned int clientID);
+    unsigned int getRTT(unsigned int clientID);
+    virtual void printRTT();
     double getPacketLoss(unsigned int clientID);
   protected:
@@ -65,8 +66,8 @@
     unsigned int shipID(){return 0;}
     unsigned int playerID(){return 0;}
-    
+
     void addPeer(ENetEvent *event);
     void removePeer(ENetEvent *event);
-    
+
     bool createClient(int clientID);
     void disconnectClient( ClientInformation *client);
Index: code/branches/pickup2/src/libraries/network/TrafficControl.cc
===================================================================
--- code/branches/pickup2/src/libraries/network/TrafficControl.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/network/TrafficControl.cc	(revision 6412)
@@ -64,24 +64,24 @@
 *Initializing protected members
 */
-	TrafficControl *TrafficControl::instance_=0;
-
-	/**
-	* @brief Constructor: assures that only one reference will be created and sets the pointer
-	*/
-	TrafficControl::TrafficControl()
-	{
+    TrafficControl *TrafficControl::instance_=0;
+
+    /**
+    * @brief Constructor: assures that only one reference will be created and sets the pointer
+    */
+    TrafficControl::TrafficControl()
+    {
     RegisterObject(TrafficControl);
-	  assert(instance_==0);
-	  instance_=this;
+      assert(instance_==0);
+      instance_=this;
     this->setConfigValues();
-	}
-
-	/**
-	* @brief Destructor: resets the instance pointer to 0
-	*/
-	TrafficControl::~TrafficControl()
-	{
-	  instance_=0;
-	}
+    }
+
+    /**
+    * @brief Destructor: resets the instance pointer to 0
+    */
+    TrafficControl::~TrafficControl()
+    {
+      instance_=0;
+    }
 
 /**
@@ -121,11 +121,11 @@
 
 
-	void TrafficControl::processObjectList(unsigned int clientID, unsigned int gamestateID, std::list<obj>& list)
-	{
-	  currentClientID=clientID;
-	  currentGamestateID=gamestateID;
-	  evaluateList(clientID, list);
-	  return;
-	}
+    void TrafficControl::processObjectList(unsigned int clientID, unsigned int gamestateID, std::list<obj>& list)
+    {
+      currentClientID=clientID;
+      currentGamestateID=gamestateID;
+      evaluateList(clientID, list);
+      return;
+    }
 
   TrafficControl *TrafficControl::getInstance()
@@ -135,9 +135,9 @@
   }
 
-	void TrafficControl::ack(unsigned int clientID, unsigned int gamestateID)
-	{
+    void TrafficControl::ack(unsigned int clientID, unsigned int gamestateID)
+    {
     if ( !this->bActive_ )
       return;
-	  std::list<obj>::iterator itvec;  // iterator to iterate through the acked objects
+      std::list<obj>::iterator itvec;  // iterator to iterate through the acked objects
 
     //assertions to make sure the maps already exist
@@ -145,5 +145,5 @@
     assert(clientListPerm_.find(clientID) != clientListPerm_.end() );
     assert( clientListTemp_[clientID].find(gamestateID) != clientListTemp_[clientID].end() );
-    
+
     // shortcut for maps
     std::map<unsigned int, objInfo >& objectListPerm = clientListPerm_[clientID];
@@ -151,22 +151,22 @@
 
     for(itvec = objectListTemp[gamestateID].begin(); itvec != objectListTemp[gamestateID].end(); itvec++)
-	  {
-      if(objectListPerm.find((*itvec).objID) != objectListPerm.end()) // check whether the obj already exists in our lists
-      {
-        objectListPerm[(*itvec).objID].objCurGS = gamestateID;
-        objectListPerm[(*itvec).objID].objValueSched = 0; //set scheduling value back
+      {
+      if(objectListPerm.find(itvec->objID) != objectListPerm.end()) // check whether the obj already exists in our lists
+      {
+        objectListPerm[itvec->objID].objCurGS = gamestateID;
+        objectListPerm[itvec->objID].objValueSched = 0; //set scheduling value back
       }
       else
       {
         assert(0);
-        objectListPerm[(*itvec).objID].objCurGS = gamestateID;
-        objectListPerm[(*itvec).objID].objID = (*itvec).objID;
-        objectListPerm[(*itvec).objID].objCreatorID = (*itvec).objCreatorID;
-        objectListPerm[(*itvec).objID].objSize = (*itvec).objSize;
-      }
-	  }
-	   // remove temporary list (with acked objects) from the map
+        objectListPerm[itvec->objID].objCurGS = gamestateID;
+        objectListPerm[itvec->objID].objID = itvec->objID;
+        objectListPerm[itvec->objID].objCreatorID = itvec->objCreatorID;
+        objectListPerm[itvec->objID].objSize = itvec->objSize;
+      }
+      }
+       // remove temporary list (with acked objects) from the map
     objectListTemp.erase( objectListTemp.find(gamestateID) );
-	}
+    }
 
 /**
@@ -174,14 +174,14 @@
 */
 
-	/**
-	*updateClientListPerm
-	*returns void
-	*/
-	void TrafficControl::insertinClientListPerm(unsigned int clientID, obj objinf)
-	{
-	  std::map<unsigned int,std::map<unsigned int, objInfo> >::iterator itperm;//iterator clientListPerm over clientIDs
+    /**
+    *updateClientListPerm
+    *returns void
+    */
+    void TrafficControl::insertinClientListPerm(unsigned int clientID, obj objinf)
+    {
+      std::map<unsigned int,std::map<unsigned int, objInfo> >::iterator itperm;//iterator clientListPerm over clientIDs
     unsigned int gsid=GAMESTATEID_INITIAL, gsdiff=currentGamestateID, prioperm=Synchronisable::getSynchronisable(objinf.objID)->getPriority(), priomom=0;
     clientListPerm_[clientID][objinf.objID] = objInfo(objinf.objID, objinf.objCreatorID,gsid,gsdiff, objinf.objSize,prioperm,priomom);
-	}
+    }
 
   /**
@@ -205,13 +205,13 @@
     for(itvec = list.begin(); itvec != list.end();)
     {
-      assert( (*itvec).objSize < 1000);
-      if ( ( size + (*itvec).objSize ) < targetsize )
-      {
-        size += (*itvec).objSize;//objSize is given in bytes
+      assert( itvec->objSize < 1000);
+      if ( ( size + itvec->objSize ) < targetsize )
+      {
+        size += itvec->objSize;//objSize is given in bytes
         ++itvec;
       }
       else
       {
-        clientListPerm_[currentClientID][(*itvec).objID].objValueSched += SCHED_PRIORITY_OFFSET; // NOTE: SCHED_PRIORITY_OFFSET is negative
+        clientListPerm_[currentClientID][itvec->objID].objValueSched += SCHED_PRIORITY_OFFSET; // NOTE: SCHED_PRIORITY_OFFSET is negative
         list.erase(itvec, list.end());
         break;
@@ -223,9 +223,9 @@
 
 
-	/**
-	*evaluateList evaluates whether new obj are there, whether there are things to be updatet and manipulates all this.
-	*/
-	void TrafficControl::evaluateList(unsigned int clientID, std::list<obj>& list)
-	{
+    /**
+    *evaluateList evaluates whether new obj are there, whether there are things to be updatet and manipulates all this.
+    */
+    void TrafficControl::evaluateList(unsigned int clientID, std::list<obj>& list)
+    {
 
     if( bActive_ )
@@ -236,14 +236,14 @@
       //if listToProcess contains new Objects, add them to clientListPerm
       std::list<obj>::iterator itvec;
-    
+
       std::map<unsigned int, objInfo >& objectListPerm = clientListPerm_[clientID];
-    
+
       for( itvec=list.begin(); itvec != list.end(); itvec++)
       {
-        if ( objectListPerm.find( (*itvec).objID) != objectListPerm.end() )
+        if ( objectListPerm.find( itvec->objID) != objectListPerm.end() )
         {
         // we already have the object in our map
         //obj bleibt in liste und permanente prio wird berechnet
-          objectListPerm[(*itvec).objID].objDiffGS = currentGamestateID - objectListPerm[(*itvec).objID].objCurGS;
+          objectListPerm[itvec->objID].objDiffGS = currentGamestateID - objectListPerm[itvec->objID].objCurGS;
           continue;//check next objId
         }
@@ -256,10 +256,10 @@
       }
     //end compare listToProcess vs clientListPerm
-      
+
       //sort copied list according to priorities
       // use boost bind here because we need to pass a memberfunction to stl sort
 //       sort( list.begin(), list.end(), boost::bind(&TrafficControl::prioritySort, this, clientID, _1, _2) );
       list.sort( boost::bind(&TrafficControl::prioritySort, this, clientID, _1, _2) );
-      
+
 //       list.sort(boost::bind(&TrafficControl::prioritySort, this, clientID, _1, _2) );
 
@@ -277,5 +277,5 @@
 //       sort(list.begin(), list.end(), boost::bind(&TrafficControl::dataSort, this, _1, _2) );
       list.sort( boost::bind(&TrafficControl::dataSort, this, _1, _2) );
-      
+
       //diese Funktion updateClientList muss noch gemacht werden
       updateClientListTemp(list);
@@ -289,17 +289,17 @@
     COUT(0) << "=========== Objectlist ===========" << endl;
     for( it=list.begin(); it!=list.end(); it++)
-      COUT(0) << "ObjectID: " << (*it).objID << " creatorID: " << (*it).objCreatorID << " Priority: " << clientListPerm_[clientID][(*it).objID].objValuePerm + clientListPerm_[clientID][(*it).objID].objValueSched << " size: " << (*it).objSize << endl;
+      COUT(0) << "ObjectID: " << it->objID << " creatorID: " << it->objCreatorID << " Priority: " << clientListPerm_[clientID][it->objID].objValuePerm + clientListPerm_[clientID][it->objID].objValueSched << " size: " << it->objSize << endl;
   }
 
   void TrafficControl::fixCreatorDependencies(std::list<obj>::iterator it1, std::list<obj>& list, unsigned int clientID)
   {
-    if ( (*it1).objCreatorID == OBJECTID_UNKNOWN )
-      return;
-    if( clientListPerm_[clientID][(*it1).objCreatorID].objCurGS != GAMESTATEID_INITIAL )
+    if ( it1->objCreatorID == OBJECTID_UNKNOWN )
+      return;
+    if( clientListPerm_[clientID][it1->objCreatorID].objCurGS != GAMESTATEID_INITIAL )
       return;
     std::list<obj>::iterator it2, it3=it1;
     for( it2 = ++it3; it2 != list.end(); it2++ )
     {
-      if( (*it2).objID == (*it1).objCreatorID )
+      if( it2->objID == it1->objCreatorID )
       {
         it3 = list.insert(it1, *it2); //insert creator before it1
